#pragma once
#include <utils.h>
#include "Entity3d.h"
#include "../../disjoint/DisjointSets.h"
#include "Vector3d.h"
#include "WindowMapping.h"

#define TEXTURE_COUNT 5

class Entity3dCollection
{
public:

	void AddEntity(int generator_id, WindowMapping &mapping, EntityRenderedType m_targetType, int center_x, int center_y,
		ConnectionStruct &connectivity,	int spanX = 1, int spanY = 1, int spanZ = 1);

	//shortcut
	void AddEntity(int generator_id, WindowMapping &mapping, EntityRenderedType m_targetType, int center_x, int center_y,
		unsigned char connectivityValue = 0, int spanX = 1, int spanY = 1, int spanZ = 1);

	void SetEntityVariable(int x, int y, int varindex, float var);

	void GetAdjacentHeights(int x, int y, float *heights);

	float GetEntityVariable(int x, int y, int index);

	void Clear();
	void Render(GLuint *textures, GLuint firstEntityList);
	void CompileDisplayLists(GLuint firstEntityList, float height);

	bool ConstrainToIndoors(Vector3d &originalPoint, Vector3d &delta, int gridx, int gridy, WindowMapping &mapping);

	void GetNodeExits(int x, int y, ConnectionStruct &exits);

	void EnsureAdjacentConnectivity();

	DisjointSets m_disjointSets;

	Entity3dCollection(void);
	~Entity3dCollection(void);
private:
	Entity3d m_entities[MAX_ENTITIES][MAX_ENTITIES];
	void DiscoverConnectedNodes(int x, int y, ConnectionStruct &connections, bool excludeBoxes = false);
	void UnionTwoNodes(int x, int y, int deltax, int deltay);
	bool AreDisjoint(int x, int y, int deltax, int deltay);
	void RenderSingleNode(int x, int y, int texture, bool shouldBakeCollisions);
};